#!/usr/bin/env python

# generate alter table test cases for integer types

import sys
def gen_test(types, values):
    assert len(types) == 5;
    print "CREATE TABLE tt (a %s, b %s, c %s, d %s, e %s);" % (types[0], types[1], types[2], types[3], types[4])
    # generate the cross product of all of the values
    for a in values[0]:
        for b in values[1]:
            for c in values[2]:
                for d in values[3]:
                    for e in values[4]:
                        print "INSERT INTO tt VALUES (%d,%d,%d,%d,%d);" % (a, b, c, d, e)
    print "CREATE TABLE ti like tt;"
    print "ALTER TABLE ti ENGINE=myisam;"
    print "INSERT INTO ti SELECT * from tt;"
    print "ALTER TABLE tt CHANGE COLUMN a a %s, CHANGE COLUMN b b %s, CHANGE COLUMN c c %s, CHANGE COLUMN d d %s;" % (types[1], types[2], types[3], types[4])
    print "SHOW CREATE TABLE tt;"
    # leave the isam table with the original types.  values should be the same.
    print "#ALTER TABLE ti CHANGE COLUMN a a %s, CHANGE COLUMN b b %s, CHANGE COLUMN c c %s, CHANGE COLUMN d d %s;" % (types[1], types[2], types[3], types[4])
    print "SHOW CREATE TABLE ti;"
    print "let $diff_tables = test.tt, test.ti;"
    print "source include/diff_tables.inc;"
    print "DROP TABLE tt, ti;"
def main():
    print "# this test is generated by change_int_data.py"
    print "--disable_warnings"
    print "DROP TABLE IF EXISTS tt, ti;"
    print "--enable_warnings"
    print "SET SESSION DEFAULT_STORAGE_ENGINE=\"TokuDB\";"
    print "SET SESSION TOKUDB_DISABLE_SLOW_ALTER=1;"
    gen_test(
        [ "TINYINT", "SMALLINT", "MEDIUMINT", "INT", "BIGINT" ], 
        [ [ -128, -1, 0, 1, 127 ], [ -32768, -1, 0, 1, 32767], [-8388608, -1, 0, 1, 8388607], [-2147483648, 0, 1, 2147483647], [-9223372036854775808, 0, 1, 9223372036854775807] ]
    )
    gen_test(
        [ "TINYINT UNSIGNED", "SMALLINT UNSIGNED", "MEDIUMINT UNSIGNED", "INT UNSIGNED", "BIGINT UNSIGNED" ],
        [ [ 0, 1, 255 ], [ 0, 1, 65535], [0, 1, 16777215], [0, 1, 4294967295], [0, 1, 18446744073709551615] ]
    )
    return 0
sys.exit(main())
